function reverseString(str) {
	return str.split("").reverse().join("")
}

function index(value, base, chars) {
	let str = "";

	while (true) {
		let digit = value % base;

		str += chars[digit];

		value = Math.floor(value / base);

		if (!value) break
	}

	return reverseString(str)
}

const alphabet = "abcdefghijklmnopqrstuvwxyz";

function AlphabetIdentifierGenerator() {
	let current_index = 0;
	let map = {};

	this.insert = (value) => {
		value = value.toString();

		if (value in map) {
			throw new Error(`Duplicate entry '${value}'`)
		}

		let index$1 = current_index;

		map[value] = index$1;

		++current_index;

		return index(index$1, alphabet.length, alphabet)
	};

	this.lookup = (value) => {
		value = value.toString();

		if (!(value in map)) {
			throw new Error(`No such entry '${value}'`)
		}

		return index(map[value], alphabet.length, alphabet)
	};
}

export { AlphabetIdentifierGenerator as default };
